import java.util.Set;

/**
 * Test program that looks for violations of thread safety of the
 * TicketMachine Singleton class.
 * 
 * @author Uno Holmer
 * @version 2010-10-12
 */

public class Main {
    public static void main(String[] arg) {
        int nOofThreads = Integer.parseInt(arg[0]);
        int noOfSteps = Integer.parseInt(arg[1]);
        
        // Create a bunch of threads
        UserThread[] threads = new UserThread[nOofThreads];
        for ( int i = 0; i < nOofThreads; i++ )
            threads[i] = new UserThread(noOfSteps);
           
        // Start the threads
        for ( int i = 0; i < nOofThreads; i++ )
            threads[i].start();
        
        // Wait for all threads to finish
        try {
            for ( int i = 0; i < nOofThreads; i++ )
                threads[i].join();
        }
        catch( InterruptedException e ) {
            System.out.println("A thread was interrupted");
        }
        
        // Look for duplicates
        for ( int i = 0; i < nOofThreads; i++ )
            for ( int j = i+1; j < nOofThreads; j++ )
                if ( hasCommonElements(threads[i].getNumbers(),
                                       threads[j].getNumbers()) ) 
                {
                    System.out.println("Duplicate found");
                    return;
                }
        System.out.println("No duplicate found");    }
    
    private static boolean hasCommonElements(Set<Integer> a,Set<Integer> b) {
        for ( int x : a )
            if ( b.contains(x) )
                return true;
        return false;
    }
}
