/**
 * TicketMachine Relatively thread safe implementation of a Singleton class.
 * 
 * @author Uno Holmer
 * @version 2010-10-12
 */

public class TicketMachine {
    private static TicketMachine instance = null;
    private int count;

    // This forbids external object creation.
    private TicketMachine() { count = 0; }
    
    // Return the single object of this class, 
    // create lazily if necessary.
    public static synchronized TicketMachine getInstance() {
        if ( instance == null )
            instance = new TicketMachine();
        return instance;
    }
    
    public synchronized int getTicket() {
        return ++count;
    }
}
