import java.util.Set;
import java.util.HashSet;

/**
 * UserThread collects ticket numbers from a TicketMachine.
 * 
 * @author Uno Holmer
 * @version 2010-10-12
 */

public class UserThread extends Thread {
    private int noOfSteps = 0;
    private Set<Integer> numbers;
    
    public UserThread(int noOfSteps) {
        this.noOfSteps = noOfSteps;
        numbers = new HashSet<Integer>(noOfSteps);
    }
    
    public Set<Integer> getNumbers() {
        return numbers;
    }
    
    public void run()  {
        TicketMachine tm = TicketMachine.getInstance();
        int i = 0;
        while ( i++ < noOfSteps && ! interrupted() ) {
            int n = tm.getTicket();
            numbers.add(n);
        }
    }
}
